/*
 * Copyright © 2021 Fachhochschule für die Wirtschaft (FHDW) Hannover
 *
 * This file is part of ipspiel22-tictactoe-core.
 *
 * ipspiel22-tictactoe-core is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * ipspiel22-tictactoe-core is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * ipspiel22-tictactoe-core. If not, see <http://www.gnu.org/licenses/>.
 */
package de.fhdw.gaming.ipspiel22.tictactoe.core.domain;

import de.fhdw.gaming.core.domain.GameBuilderFactory;
import de.fhdw.gaming.core.domain.GameException;
import de.fhdw.gaming.core.ui.InputProvider;

/**
 * A Tic Tac Toe {@link GameBuilderFactory} which allows to create a Tic Tac Toe game builder.
 */
public interface TicTacToeGameBuilderFactory extends GameBuilderFactory {

    /**
     * Parameter for the number of rows (and columns) of the board.
     */
    String PARAM_BOARD_SIZE = "boardSize";
    /**
     * Parameter that determines if a player is using crosses or noughts.
     */
    String PARAM_PLAYER_USING_CROSSES = "playerUsingCrosses";

    @Override
    TicTacToeGameBuilder createGameBuilder(InputProvider inputProvider) throws GameException;
}
